// Generated by CoffeeScript 2.3.1
(function() {
  var fromAJson, isArray, isNumber, isPlainObject, isString, reMap, toAJson, unalias;

  isArray = function(x) {
    return Array.isArray(x);
  };

  isString = function(x) {
    return (typeof x === "string") || (x instanceof String);
  };

  isNumber = function(x) {
    return (typeof x === "number") || (x instanceof Number);
  };

  isPlainObject = function(x) {
    if (isArray(x) || isNumber(x) || isString(x)) {
      return false;
    }
    return true;
  };

  reMap = function(map) {
    return function($) {
      return function(x) {
        if ((isString(x)) && x.startsWith($)) {
          return map[x];
        }
        return x;
      };
    };
  };

  toAJson = function(root, $ = "$") {
    var _getOrAdd, count, dict, e, l, map, myMap, res;
    dict = {};
    _getOrAdd = function(o) {
      var aux, i, l, len, oLabel, oValue, ref;
      if (isArray(o)) {
        oValue = o.map(_getOrAdd);
        oLabel = `${$}[${oValue.join(',')}]`;
      } else if (isPlainObject(o)) {
        oValue = {};
        aux = [];
        ref = Object.keys(o).sort();
        for (i = 0, len = ref.length; i < len; i++) {
          l = ref[i];
          oValue[l] = _getOrAdd(o[l]);
          aux.push(`${l}:${oValue[l]}`);
        }
        oLabel = `${$}{${aux.join(',')}}`;
      } else {
        return o;
      }
      if (dict[oLabel] == null) {
        dict[oLabel] = oValue;
      }
      return oLabel;
    };
    root = _getOrAdd(root);
    count = 0;
    map = {};
    res = {};
    for (l in dict) {
      e = dict[l];
      map[l] = $ + count.toString(36);
      count++;
    }
    myMap = reMap(map)($);
    for (l in dict) {
      e = dict[l];
      res[map[l]] = Object.keys(e).reduce(function(r, key) {
        var val;
        val = e[key];
        r[key] = myMap(val);
        return r;
      }, isArray(e) ? [] : {});
    }
    if (root === myMap(root)) {
      return root;
    }
    return res;
  };

  fromAJson = function(aJson, $ = '$') {
    var e, l, myMap, result;
    result = "";
    if (!isPlainObject(aJson)) {
      return aJson;
    }
    myMap = (reMap(aJson))($);
    for (l in aJson) {
      e = aJson[l];
      result = aJson[l] = Object.keys(e).reduce(function(r, k) {
        var v;
        v = e[k];
        r[k] = aJson[k] = myMap(v);
        return r;
      }, isArray(e) ? [] : {});
    }
    return result;
  };

  unalias = function(obj, $ = "$") {
    var e, l, mem, myMap, res, sub;
    if (!obj[$]) {
      return obj;
    }
    myMap = (reMap(obj[$]))($);
    res = {};
    mem = {};
    sub = function(o) {
      var aux;
      if (isArray(o) || isPlainObject(o)) {
        return Object.keys(o).reduce(function(r, k) {
          var v;
          v = o[k];
          r[k] = sub(v);
          return r;
        }, isArray(o) ? [] : {});
      } else {
        aux = myMap(o);
        if (aux === o) {
          return aux;
        }
        if (mem[o]) {
          return mem[o];
        }
        mem[o] = `ERROR: circular definition for ${o}`;
        return mem[o] = sub(myMap(o));
      }
    };
    for (l in obj) {
      e = obj[l];
      if (l !== $) {
        res[l] = sub(e);
      }
    }
    return res;
  };

  module.exports = {
    pack: toAJson,
    unpack: fromAJson,
    unalias: unalias
  };

}).call(this);
